
PlayerMessageNode = class( Turbine.UI.TreeNode );


function PlayerMessageNode:Constructor(p, parent, hightlight)
	self.player = p;
	
	Turbine.UI.TreeNode.Constructor( self );    	
	self:SetSize( 312, 70 );
	self:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );

	self.lefttopbox = Turbine.UI.Label();
	self.lefttopbox:SetParent( self );
	self.lefttopbox:SetPosition(0, 0);
	self.lefttopbox:SetSize(37, 30);
	self.lefttopbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.lefttopbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_lt.tga");	
	self.leftmidbox = Turbine.UI.Label();
	self.leftmidbox:SetParent( self );
	self.leftmidbox:SetPosition(0, 30);
	self.leftmidbox:SetSize(37, 1);
	self.leftmidbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.leftmidbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_lm.tga");
	self.leftbotbox = Turbine.UI.Label();
	self.leftbotbox:SetParent( self );
	self.leftbotbox:SetPosition(0, 30);
	self.leftbotbox:SetSize(37, 4);
	self.leftbotbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.leftbotbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_lb.tga");	
	self.righttopbox = Turbine.UI.Label();
	self.righttopbox:SetParent( self );
	self.righttopbox:SetPosition(0, 0);
	self.righttopbox:SetSize(6, 30);
	self.righttopbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.righttopbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_rt.tga");	
	self.rightmidbox = Turbine.UI.Label();
	self.rightmidbox:SetParent( self );
	self.rightmidbox:SetPosition(0, 30);
	self.rightmidbox:SetSize(6, 1);
	self.rightmidbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.rightmidbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_rm.tga");
	self.rightbotbox = Turbine.UI.Label();
	self.rightbotbox:SetParent( self );
	self.rightbotbox:SetPosition(0, 30);
	self.rightbotbox:SetSize(6, 4);
	self.rightbotbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.rightbotbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_rb.tga");
	self.centtopbox = Turbine.UI.Label();
	self.centtopbox:SetParent( self );
	self.centtopbox:SetPosition(37, 0);
	self.centtopbox:SetSize(1, 30);
	self.centtopbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.centtopbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_ct.tga");	
	self.centmidbox = Turbine.UI.Label();
	self.centmidbox:SetParent( self );
	self.centmidbox:SetPosition(37, 30);
	self.centmidbox:SetSize(1, 1);
	self.centmidbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.centmidbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_cm.tga");
	self.centbotbox = Turbine.UI.Label();
	self.centbotbox:SetParent( self );
	self.centbotbox:SetPosition(37, 30);
	self.centbotbox:SetSize(1, 4);
	self.centbotbox:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.centbotbox:SetBackground("WalmPlugins/BandOfFarmers/pictures/Nodes/box2_cb.tga");	

	self.closeButton = Turbine.UI.Label();
	self.closeButton:SetParent( self );
	self.closeButton:SetBackground( "WalmPlugins/BandOfFarmers/pictures/close.jpg" );
	self.closeButton:SetSize(16, 16);
	self.closeButton:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.closeButton.MouseClick = function (sender, args)
		if(self.extended==true) then
			self.extended = false;
			self.textArea:SetText(nil);
			parent:UpdateAndSavePlayerMessage(self.player.name, nil, nil);
			self:UpdateResponsive(self:GetWidth(), 36);
		else
			self.extended = true;
			self:UpdateResponsive(self:GetWidth(), 70);
		end
	end
	self.closeButton.MouseEnter = function (sender, args)
		if(self.extended==true) then
			self.closeButton:SetBackground( "WalmPlugins/BandOfFarmers/pictures/close_roll.jpg" );
		end
	end
	self.closeButton.MouseLeave = function (sender, args)
		if(self.extended==true) then
			self.closeButton:SetBackground( "WalmPlugins/BandOfFarmers/pictures/close.jpg" );
		end
	end	
	
	
	self.playerNameLabel = Turbine.UI.Label();
	self.playerNameLabel:SetParent( self );
	self.playerNameLabel:SetSize( 180, 16 );
	self.playerNameLabel:SetPosition( 42, 3 );
	self.playerNameLabel:SetZOrder(100);
	self.playerNameLabel:SetFont( Turbine.UI.Lotro.Font.TrajanPro14	 );	
	self.playerNameLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	self.playerNameLabel:SetMouseVisible( false );
	--self.playerNameLabel:SetBackColor(Turbine.UI.Color( 0, 0, 1 ));
	-- if(self.player.data==nil or self.player.data.level == nil) then
		-- self.playerNameLabel:SetText(self.player.name);
		-- self.playerNameLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	-- else
	self.playerNameLabel:SetText("["..(self.player.data.level or "???").."] "..self.player.name);
	-- end

	if(hightlight==true) then
		self.playerNameLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	end	
	
	self.classLabel = Turbine.UI.Control();
	self.classLabel:SetParent( self );
	self.classLabel:SetSize( 20, 20 );
	self.classLabel:SetPosition( 9, 7 );
	if(self.player.data==nil) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_normal.tga";
		self.classLabel:SetPosition( 6, 5 );
		self.classLabel:SetSize( 26, 24 );
	elseif(self.player.data.playerClass == 172) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_champion_20.tga";
	elseif(self.player.data.playerClass == 214) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_beorning_20.tga";
	elseif(self.player.data.playerClass == 40) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_burglar_20.tga";
	elseif(self.player.data.playerClass == 23) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_guardian_20.tga";
	elseif(self.player.data.playerClass == 194) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_warden_20.tga";
	elseif(self.player.data.playerClass == 193) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_runekeeper_20.tga";
	elseif(self.player.data.playerClass == 185) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_loremaster_20.tga";
	elseif(self.player.data.playerClass == 162) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_hunter_20.tga";
	elseif(self.player.data.playerClass == 31) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_minstrel_20.tga";
	elseif(self.player.data.playerClass == 24) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_captain_20.tga";
	elseif(self.player.data.playerClass == 215) then
		self.classLabel.defaultBackground = "WalmPlugins/BandOfFarmers/pictures/fellowship_brawler_20.tga";
	else
		self.classLabel:SetBackground( "WalmPlugins/BandOfFarmers/pictures/fellowship_normal.tga");
		self.classLabel:SetPosition( 6, 5 );
		self.classLabel:SetSize( 26, 24 );
	end
	self.classLabel:SetBackground(self.classLabel.defaultBackground);
	self.classLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	--self.classLabel:SetMouseVisible( false );
	self.classLabel.tooltip = GenericTooltip(self.classLabel);
	self.classLabel.tooltip:AddLayer( _("DELCHAR"), Turbine.UI.Color(207/255,181/255,59/255), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
	self.classLabel.tooltip:AddLayer(_("DELCHAR_DESCRIPTION"),  Turbine.UI.Color(1,1,1), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);


	local iconeTop = 9;
	
	self.textArea = Turbine.UI.Lotro.TextBox();
	self.textArea:SetParent( self );
	self.textArea:SetPosition( 38, 24 );
	self.textArea:SetSize( self:GetWidth()-54, 40 );
	self.textArea:SetFont(Turbine.UI.Lotro.Font.Verdana12);
	self.scrollBar = Turbine.UI.Lotro.ScrollBar();
    self.scrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
    self.scrollBar:SetParent( self );
    self.scrollBar:SetPosition( self.textArea:GetLeft()+self.textArea:GetWidth(), self.textArea:GetTop() );
    self.scrollBar:SetSize( 10, self.textArea:GetHeight() );
	self.textArea:SetVerticalScrollBar( self.scrollBar );	

	self.textArea:SetText(self.player.message);
	self.textArea.FocusLost = function()
		parent:UpdateAndSavePlayerMessage(self.player.name, self.textArea:GetText(), self:GetHeight());
		--self.player.message = self.textArea:GetMessage();
	end

	self.resizer = Turbine.UI.Label();
	self.resizer:SetParent( self );
	self.resizer:SetSize(100, 10);
	self.resizer:SetBackground("WalmPlugins/BandOfFarmers/pictures/v_resize.jpg");
	self.resizer:SetPosition(self:GetWidth()/2-50, self:GetHeight()-10);
	self.resizer:SetZOrder(self:GetZOrder()+10);

	self.resizer.MouseDown = function( sender, args )
		if(args.Button == Turbine.UI.MouseButton.Left) then
			sender.dragStartX = args.X;
			sender.dragStartY = args.Y;
			sender.dragging = true;
			sender.dragged = false;
		end
	end
	self.resizer.MouseUp = function( sender, args )
		if (args.Button == Turbine.UI.MouseButton.Left) then			
			if (sender.dragging) then
				sender.dragging = false;
			end
			parent:UpdateAndSavePlayerMessage(self.player.name, self.textArea:GetText(), self:GetHeight());
		end
	end
	self.resizer.MouseMove = function(sender,args)
		if ( sender.dragging ) then
			local height = self:GetHeight() + args.Y - sender.dragStartY;
			if(height>70) then 
				self:SetHeight(height);
			end
			self:UpdateResponsive(self:GetWidth(), self:GetHeight());
		end
	end	
	
	self.extended = (self.player.message~=nil and self.player.message~="");
	self:UpdateNodeData();
	if(self.extended==false) then
		self:UpdateResponsive(self:GetWidth(), 36);
	else
		self:UpdateResponsive(self:GetWidth(), self.player.messageHeight or 76);
	end
	self.MouseEnter = function()
		self.classLabel:SetBackground("WalmPlugins/BandOfFarmers/pictures/delete.tga");
	end
	self.MouseLeave = function()
		self.classLabel:SetBackground(self.classLabel.defaultBackground);
	end
	self.classLabel.MouseClick = function()
		bofDlg:DeleteCharacterData(self.player.name);
	end	
end

function PlayerMessageNode:UpdateResponsive(width, height)
	self:SetSize(width, height);
	if(self.extended==false) then

	end
	self.resizer:SetVisible(self.extended);
	self.scrollBar:SetVisible(self.extended);
	self.textArea:SetVisible(self.extended);
	
	self.resizer:SetPosition(self:GetWidth()/2-50, self:GetHeight()-10);
	self.closeButton:SetPosition( self:GetWidth()-19, 3 );	
	
	self.textArea:SetSize( self:GetWidth()-54, self:GetHeight()-35 );
    self.scrollBar:SetPosition( self.textArea:GetLeft()+self.textArea:GetWidth(), self.textArea:GetTop() );
    self.scrollBar:SetSize( 10, self.textArea:GetHeight() );	
	
	self.leftmidbox:SetHeight(height-34);
	self.leftbotbox:SetTop(height-4);
	self.righttopbox:SetLeft(width-6);
	self.rightmidbox:SetLeft(width-6);
	self.rightmidbox:SetHeight(height-34);
	self.rightbotbox:SetPosition(width-6, height-4);
	self.centtopbox:SetWidth(width-43);
	self.centmidbox:SetSize(width-43, height-34);
	self.centbotbox:SetTop(height-4);
	self.centbotbox:SetWidth(width-43);	
	
	if(self.extended==true) then
		self.closeButton:SetBackground( "WalmPlugins/BandOfFarmers/pictures/close_roll.jpg" );
		self.playerNameLabel:SetPosition( 42, 3 );
	else
		self.closeButton:SetBackground( "WalmPlugins/BandOfFarmers/pictures/closeAdd.tga" );
		self.playerNameLabel:SetPosition( 42, 9 );
	end
end

function PlayerMessageNode:GetPlayer()
	return self.player;
end

function PlayerMessageNode:UpdateNodeData(p)
	if p~= nil and p.name == self.player.name  then
		--
	end
end
