TabButton = class( Turbine.UI.Label );

function TabButton:Constructor(label, selected)	  	
	Turbine.UI.Label.Constructor( self );    	
	
	self:SetSize( 60, 24 );
	self:SetBackground("WalmPlugins/BandOfFarmers/TabDown.jpg");
	self:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );

	self.backLabel = Turbine.UI.Label();
	self.backLabel:SetParent( self );
	self.backLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);	
	self.backLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);	
	self.backLabel:SetText( label );
	--backLabel:SetForeColor(Turbine.UI.Color( 0.9, 0.9, 0.9));
	self.backLabel:SetPosition( 0, 0 );
	self.backLabel:SetSize(self:GetWidth(), self:GetHeight()-2);
	self.backLabel:SetMouseVisible( false );
	
	self:SetSelected(selected);
end

function TabButton:SetSelected(selected)
	self.Selected = selected;
	
	if(selected) then
		self:SetBackground("WalmPlugins/BandOfFarmers/TabUp.jpg");
		self.backLabel:SetForeColor(Turbine.UI.Color( 0.9, 0.9, 0.2));	
	else
		self:SetBackground("WalmPlugins/BandOfFarmers/TabDown.jpg");
		self.backLabel:SetForeColor(Turbine.UI.Color( 0.9, 0.9, 0.9));	
	end
end

function TabButton:IsSelected()
	return self.Selected;
end
